      program chancomp
      implicit none

      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)

      call ismain( nbuffr )

      end

      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate
c     y        i    y-coordinate
c     t        i    actual time
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

      if ( ichoice.eq.1 ) then

c      --- ichoice = 1, prescribe m_n
c          In order to avoid a transient the momentum starts with 0 at t=0
c          and gradually rises to -1 at t = 1
c          hence u_n = -1/2 t (t<2)
c                u_n = -1     (t>=2)

         if (t .le. 2d0) then
           usfunb = -.5d0*1d0*t
         else
           usfunb = -1d0
         end if
      end if
      end
