      program transax1
      implicit none

      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)

      call ismain( nbuffr )

      end

      function usfunc ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     coefficient as a function of space, time and previously computed
c     solutions.

      implicit none      

      integer ichoice
      double precision usfunc, x, y, z, t

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunc   o    computed coefficient


         if ( ichoice.eq.1 ) then
              usfunc = -1d0/x
	 else if ( ichoice .eq. 2 ) then
	       usfunc = -1d0*(4d0*x+y)/x
	 else if ( ichoice .eq. 3 ) then
	       usfunc = -1d0*(sin(x)+sin(y)+3*x*cos(x)-x*x*sin(x))/x +
     +                    x*sin(y) 	       
         end if

      end

      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none      

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

         if ( ichoice.eq.1 ) then
            usfunb = x
	 else if ( ichoice .eq. 2 ) then
	    usfunb = x*(x+y)
	 else if ( ichoice .eq. 3 ) then
	    usfunb = x*(sin(x)+sin(y))
         end if

      end
      function usfuni ( ichoice, x, y, z )

c     ------ dummy version

c***********************************************************************
c
c     programmer   Kees Kassels
c     version      1.0  01-03-95
c
c***********************************************************************
c
c     A user supplied function "usfuni" is needed instead of this dummy !!!
c
c     The function value
c             usfuni
c     must be filled here by the user, corresponding to his/her option
c             ...  func = ichois
c     which has occured in the INITIAL_CONDITIONS part of problem description
c
c***********************************************************************

      implicit none

      integer ichoice
      double precision usfuni, x, y, z

      if ( ichoice .eq. 1 ) then
         usfuni = x
      else if ( ichoice .eq. 2 ) then
         usfuni = x*(x+y)
      else if ( ichoice .eq. 3 ) then
         usfuni = x*(sin(x)+sin(y))
      else if ( ichoice .eq. 4 ) then
         usfuni = -y
      end if

      end
