      program isnasexe
c=======================================================================
c
c     programmer      Kees Kassels
c
c     version  1.0    date    25-03-94
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c***********************************************************************
c
c                    DESCRIPTION
c
c     ISNaS Host Program
c
c***********************************************************************
c
c                   KEYWORDS
c
c     host_program
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
c***********************************************************************
c
c                   COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 4000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c
c     IBUFFR    Integer buffer array in which all array information
c               with respect to the ISNaS software is stored.
c
c     NBUFFR    Declared length of IBUFFR
c
c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
c
c***********************************************************************
c
c                   SUBROUTINES CALLED
c
c     ISHMAIN    ISNaS host main subroutine
c
c***********************************************************************
c
c                   I/O
c
c***********************************************************************
c
c                   ERROR MESSAGES
c
c***********************************************************************
c
c                   PSEUDO CODE
c
c          initialize local buffer
c          call ISNaS host main subroutine
c
c=======================================================================

      call ismain( nbuffr )

      end

      function usfuni ( ichois, x, y, z )

c     ------ dummy version

c***********************************************************************
c
c     programmer   Kees Kassels
c     version      1.0  01-03-95
c
c***********************************************************************
c
c     A user supplied function "usfuni" is needed instead of this dummy !!!
c
c     The function value
c             usfuni
c     must be filled here by the user, corresponding to his/her option
c             ...  func = ichois
c     which has occured in the INITIAL_CONDITIONS part of problem description
c
c***********************************************************************

      implicit none

      integer ichois
      double precision usfuni, x, y, z

      if ( ichois .eq. 1 ) then
         usfuni = -x * ( 1d0 - ( x / 4d0 ) )
      else if ( ichois .eq. 2 ) then
         usfuni = x * ( 1d0 - ( x / 4d0 ) )
      else if ( ichois .eq. 3 ) then
         usfuni = -y * ( 1d0 - ( y / 4d0 ) )
      else if ( ichois .eq. 4 ) then
         usfuni = y * ( 1d0 - ( y / 4d0 ) )
      end if

      end
