      subroutine isfilb4 ( ibt1lo, ibt1hi, ibt2lo, ibt2hi, ibinfor )
c ======================================================================
c
c        programmer     ronald van Nooyen
c        version 2.0    date 06-08-1998 Guus: remove parameters
c        version 1.0    date 21-04-1995
c
c   copyright (c) 1995-1998  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c              Temporary routine to fill virtual points in infbnd
c              and bndcon
c              with value to indicate outside points except for
c              edges involved with periodical boundary conditions
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibt1lo, ibt1hi, ibt2lo, ibt2hi
      integer ibinfor(ibt1lo:ibt1hi,ibt2lo:ibt2hi)

c     ibinfor  i/o   Third part of infbnd
c     ibt1hi    i    Upper bound of first index in tangential direction
c     ibt1lo    i    Lower bound of first index in tangential direction
c     ibt2hi    i    Upper bound of second index in tangential direction
c     ibt2lo    i    Lower bound of second index in tangential direction
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer outside
      parameter (outside = 101)
      integer i, j

c     i         General loop variable
c     j         General loop variable
c     outside   Type of boundary condition for points outside the ibinfor
c               array
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c

      do j=ibt2lo,ibt2hi
         do i=ibt1lo,ibt1hi
            if (ibinfor(i,j).eq.0) ibinfor(i,j) = outside
         end do
      end do

      end
