      subroutine ismain ( nbuffr )
c ======================================================================
c
c        programmer     Kees Kassels
c        version 2.10   date 29-04-1999 Guus: layout
c        version 2.9    date 10-02-1999 KeesK: underscore removed from
c                                       subroutine names
c        version 2.8    date 15-12-1998 Guus: check on scriptfile in case of
c                                             parallel computing
c        version 2.7    date 23-11-1998 Jason: complete SPMD version
c        version 2.6    date 09-10-1998 Jason: ishmain -> is_main (SPMD)
c        version 2.5    date 13-11-1997 Fred.T new param list for is_tstep
c        version 2.4    date 06-08-1997 Guus: return in case of error
c        version 2.3    date 05-06-1997 rewritten
c        version 2.2    date 18-03-1997 Kees K: error message added
c        version 2.1    date 25-06-1996 Guus: introduction indorien
c        version 2.0    date 24-04-1996 Kees K.: call of istimi changed
c        version 1.9    date 03-04-1996 Guus: Remove mapar
c        version 1.8    date 02-04-1996 Kees K: dimension isbndcon changed
c        version 1.7    date 30-01-1996 Guus: Remove exitpvm
c        version 1.6    date 29-11-1995 Guus: Extra comments
c        version 1.5    date 13-07-1995 Guus: remove files sepcomp.xxx
c        version 1.4    date 30-05-1995 Hester: eddy added to parameter
c        version 1.3    date 03-05-1995 isfinish instead of isfinhs
c        version 1.2    date 16-01-1995 Erik: modified calls
c        version 1.1    date 31-10-1994 array coefs and geom replaced
c        version 1.0    date 30-05-1994
c
c
c
c   copyright (c) 1994-1999  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c **********************************************************************
c
c                       DESCRIPTION
c
c     ISNaS main subroutine
c
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer nbuffr

c     nbuffr    Length of buffer array ibuffr
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer  istation, itimeact
      double precision t0, tact, tend, eps, tout, rout

c     eps       Accuracy with respect to the time parameter tout
c     istation  Choice whether a stationary solution is needed
c     itimeact  Actual time step
c     rout      Indicates the next time output should be performed
c     t0        Initial time
c     tact      As t, the actual time, but not in common block
c     tend      End time
c     tout      Indicates the next time output should be performed
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISBEGIN   ISNaS main start routine
c     ISSTOP    Stop ISNAS
c     ISTPAR    enroll in parallel machine
c     ISTSTEP   ISNaS time step routine
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c          call ISNaS start
c          call ISNaS time step
c          call ISNaS end
c **********************************************************************
c
c
c
c
c
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
      data itimeact /0/
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c

c     --- Default values, if no MPI support:

      iacnodes = 0
      inodenr = 0

c     --- If MPI is supported, call istpar

      call istpar

      call isbegin( nbuffr, t0, tact, tend, eps, istation )
      if ( nerror.ne.0 ) go to 1000

      do while ( tact+eps.le.tend  .and. istation.ne.-1 )

         call iststep ( tact, istation, itimeact, tout, rout )
         if ( nerror.ne.0 ) go to 1000

      end do

      call isstop

1000  end
