      subroutine isfill ( ilodest, ihidest, jlodest, jhidest,
     +                    klodest, khidest,
     +                    nslices, ifillarea, destf, fillvalue)
c=======================================================================
c
c     programmer  Ronald van Nooyen
c
c     version     1.1  ISNAS     date  30-09-94 RvN ISNaS 94 version
c     version     1.0  ISNAS     date  24-06-94
c
c     computer    HP - 9000/720
c
c     Copyright (c) 1994  "TU-Delft"
c
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "TU-Delft".
c
c     All rights reserved. No part of this publication may be reproduced,
c     stored in a retrieval system ( e.g., in memory, disk, or core)
c     or be transmitted by any means, electronic, mechanical, photocopy,
c     recording, or otherwise, without written permission from the
c     publisher.
c
c***********************************************************************
c
c                  DESCRIPTION
c
c     Fill ifillarea in dest with fillvalue
c
c***********************************************************************
c
c
c                  KEYWORDS
c
c
c***********************************************************************
c
c
c                  INPUT / OUTPUT PARAMETERS
c
      implicit none

      integer maxdim
      parameter (maxdim = 3)

      integer ifillarea(1:2,1:maxdim), nslices,
     +        ilodest, ihidest, jlodest, jhidest, klodest, khidest
      double precision fillvalue,
     +                 destf(ilodest:ihidest,jlodest:jhidest,
     +                       klodest:khidest,1:nslices)

c     destf     o    Destination of fill operation
c     fillvalue i    Fill dest with this value
c     ifillarea i    Area to be filled
c     ihidest   i    Upper bound on i-index for destination
c     ilodest   i    Lower bound on i-index for destination
c     jhidest   i    Upper bound on j-index for destination
c     jlodest   i    Lower bound on j-index for destination
c     khidest   i    Upper bound on k-index for destination
c     klodest   i    Lower bound on k-index for destination
c     maxdim    i    Highest physical space dimension for which ISNaS can work
c     nslices   i    Number of slices
c
c***********************************************************************
c
c                  COMMON BLOCKS
c
c
c***********************************************************************
c
c                  LOCAL PARAMETERS
c
c
      integer i, j, k, islice
c
c     i        General loop variable
c     islice   Loop variable for loop over slices
c     j        General loop variable
c     k        General loop variable
c
c***********************************************************************
c
c                  SAVE
c
c***********************************************************************
c
c                  DATA
c
c
c***********************************************************************
c
c                  I/O
c
c
c***********************************************************************
c
c                  SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c
c***********************************************************************
c
c                  ERROR MESSAGES
c
c
c***********************************************************************
c
c                  PSEUDO CODE
c
c
c=======================================================================

      call iseropen('isfill')

      do 10000 islice=1,nslices
         do 11000 k=ifillarea(1,3),ifillarea(2,3)
            do 11100 j=ifillarea(1,2),ifillarea(2,2)
               do 11110 i=ifillarea(1,1),ifillarea(2,1)
                  destf(i,j,k,islice) = fillvalue
11110          continue
11100       continue
11000    continue
10000 continue

      call iserclos('isfill')

      end
