      subroutine isgmatrr ( ni, nj, nvirtual, gmat, coor)
c ======================================================================
c
c        programmer     Kees Kassels
c
c        version 1.0    date 02-02-1999
c
c   copyright (c) 1999  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    multiply gradient matrix by r ( axisymmetric )
c
c **********************************************************************
c
c                       KEYWORDS
c
c    2d
c    axisymmetric
c    matrix
c    pressure_equation
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ni, nj, nvirtual
      double precision coor(1-nvirtual:ni+1+nvirtual,
     +                        1-nvirtual:nj+1+nvirtual,2),
     +                 gmat(ni+1,nj+1,2,6)

c     coor      i    reserved
c     gmat      i    Gradient matrix
c     ni        i    Number of non-virtual cells in the i-direction (one block)
c     nj        i    Number of non-virtual cells in the j-direction (one block)
c     nvirtual  i    Number of rows of virtual cells
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, j, k

c     i         General loop variable
c     j         General loop variable
c     k         General loop variable
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c

      do k = 1, 6
         do j = 1, nj
            do i = 1, ni+1
               gmat(i,j,1,k) = gmat(i,j,1,k)  * 5d-1 *
     +                          (coor(i,j,1) + coor(i,j+1,1))
            end do
         end do
         do j = 1, nj+1
            do i = 1, ni
               gmat(i,j,2,k) = gmat(i,j,2,k) * 5d-1 *
     +                          (coor(i,j,1) + coor(i+1,j,1))
            end do
         end do
      end do

      end
