      subroutine isnumsf(isitopol)
c=====================================================================
c
c        programmer   Erik Brakkee
c        version 1.0    date 23-05-94
c
c
c   copyright (c) 1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c***********************************************************************
c
c                  DESCRIPTION
c
c     Compute a unique numbering of subfaces.
c
c***********************************************************************
c
c                  KEYWORDS
c
c   topology
c***********************************************************************
c
c                  INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer isitopol

c     isitopol  i    Sequence number of array itopol
c***********************************************************************
c
c                   COMMON BLOCKS
c
      include 'IScommon/cisblank'
c***********************************************************************
c
c                   LOCAL PARAMETERS
c

      integer ipitopol, ipnsubf, ipsubf,
     +     maxnsubf, nblocks, nfaces

c     ipitopol  Starting address of array itopol in ibuffr
c     ipnsubf   Starting address of the nsubfaces array
c     ipsubf    Starting address of the subfaces array
c     maxnsubf  Maximum number of subfaces encoutered on all subfaces
c     nblocks   Number of blocks
c     nfaces    Number of faces
c**********************************************************************
c
c                   I/O
c
c      none
c
c**********************************************************************
c
c                   SUBROUTINES CALLED
c
      integer isingetp

c     ISACTIVE  Activate permanent array
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISINGETP  get the pointer corresponding to an integer array
c     ISNUMS02  Compute a unique numbering of subfaces
c**********************************************************************
c
c                   ERROR MESSAGES :
c
c***********************************************************************
c
c     PSEUDO CODE    :
c
c     Compute pointers
c     Call isnums02
c
c=======================================================================
c

      call iseropen('isnumsf')

      call isactive(isitopol)
      ipitopol = isingetp(isitopol)
      nblocks      = ibuffr(ipitopol)
      nfaces       = ibuffr(ipitopol + 1)
      maxnsubf = ibuffr(ipitopol + 2)
      ipnsubf  = ibuffr(ipitopol+5-1) + ipitopol - 1
      ipsubf   = ibuffr(ipitopol+6-1) + ipitopol - 1

      call isnums02(nblocks, nfaces, maxnsubf,
     +              ibuffr(ipnsubf), ibuffr(ipsubf))


      call iserclos('isnumsf')


      end


