      subroutine autosiz3 ( nx, ny, nz, acorsnin, ahilevel,
     +        bufsize, sl1, sl2, sl3, sl4, sl5, sl6)
c ======================================================================
c
c        programmer     Jos van Kan
c        version 1.1    date   04-06-1997
c           isnazification of all variables and subroutine calls
c           all truncated to max 8 characters.
c        version 1.0    10-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DESCRIPTION
c
c  autosize calculates the required dimension of rbuf to accomodate all
c  coarse grid info and scratch space.
c  Output in bufsize. This should (at least) be the declared
c  dimension of rbuf in the calling program to the mg - package.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer bufsize
      integer nx, ny, nz, acorsnin, ahilevel,
     + sl1, sl2, sl3, sl4, sl5, sl6

c     acorsnin  i    0=full coarsening 1=semicoarsening  (formal parameter)
c     ahilevel  i    Maximum level of coarse grids (level 0 is finest)
c                    (formal parameter)
c     bufsize   o    Size of buffer needed to accommodate all coarse grid
c                    quantities
c     nx        i    Number of grid x points on finest grid
c     ny        i    Number of grid y points on finest grid
c     nz        i    Number of points in the z-direction
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c     sl5       i    Slack variable, z lower bound
c     sl6       i    Slack variable, z upper bound
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      print *, ' You need a FORTRAN-90 compiler to use multigrid'
      stop
      end
