      subroutine pmap319 ( maparr )
c ======================================================================
c
c        programmer     Jos van Kan
c       version 1.2    date  8- 7-1997
c       version 1.1    10-04-1997
c        version 1.0    date Tue Apr  8 1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   pmap319 serves to change the default mapping of the 19-point laplacian
c   molecule. The user can change the order by giving a permutation
c   in the 19-entry array pmap of the vector 1..19.
c   The points [02][02][02] are zero coefficients. They get a default
c   mapping 20..27
c   The default mapping is:
c   0-z plane
c             22  5 23
c              2  3  4
c             20  1 21
c  1-z plane
c              12 13 14
c               9 10 11
c               6  7  8
c 2-z plane
c              26 19 27
c              16 17 18
c              24 15 25
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer maparr (27)

c     maparr    i    Contains permutation for p00 ... p22 (1..9 by
c                          default)
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      print *, ' You need a FORTRAN-90 compiler to use multigrid'
      stop
      end
