      subroutine mgexit
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   MGexit is a wrapper for an error exit out of the multi grid package
c   It has to be programmed by the incorporating application.
c
c   For ISNaS it just calls ISSTOP
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none

c ********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISSTOP    Stop ISNAS
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
c     --- MG exit basically should tie up all loose ends before halting the
c         --- program (or maybe even switch to a different solver)
c         --- This has to be programmed by the application
c         --- In this rudimentary example the program just halts.
c
c     --- In ISNaS we just ISStop
      call isstop
      end
