      subroutine mkgeom3 (ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c       version 1.2    date  8- 7-1997
c       version 1.1    10-04-1997
c        version 1.0    date Tue Apr  8 1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c **********************************************************************
c
c                       DESCRIPTION
c
c   this describes sizes on the coarser grids
c
c **********************************************************************
c
c                       KEYWORDS
c
c  multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf (*)

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ilevel

c     corsnini  Ibuf (corsnini) contains the method of coarsening
c               for this block. (fullcors or semicors) (module
c               mgpreset)
c     fullcors  Fullcoarsening (type coarsening) (module mgpreset)
c     hileveli  Ibuf (hileveli) contains the highest level of
c               coarsening for this block. (<= MAXLEVEL) (module
c               mgpreset)
c     ilevel    Levelcounter (multi grid levels)
c     sizexi    Ibuf(sizexi + ilevel)) contains number of points
c               in x direction at level ilevel. (0 = finest) (module
c               mgpreset)
c     sizeyi    Ibuf(sizeyi + ilevel)) contains number of points
c               in y direction at level ilevel. (0 = finest) (module
c               mgpreset)
c     sizezi    Ibuf(sizezi + ilevel)) contains number of points
c               in z direction at level ilevel. (0 = finest) (module
c               mgpreset)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
c     --- first we make the sizes.

      if (ibuf (corsnini).eq.FULLCORS) then
        do ilevel = 1, ibuf (hileveli)
          ibuf (sizexi + ilevel) = ibuf (sizexi + ilevel-1)/2 + 1
          ibuf (sizeyi + ilevel) = ibuf (sizeyi + ilevel-1)/2 + 1
          ibuf (sizezi + ilevel) = ibuf (sizezi + ilevel-1)/2 + 1
        end do
      else
        do ilevel = 1, ibuf (hileveli), 3
          ibuf (sizexi + ilevel) = ibuf (sizexi + ilevel-1)/2 + 1
          ibuf (sizexi + ilevel+1) = ibuf (sizexi + ilevel)
          ibuf (sizexi + ilevel+2) = ibuf (sizexi + ilevel)
          ibuf (sizeyi + ilevel) = ibuf (sizeyi + ilevel-1)
          ibuf (sizeyi + ilevel+1) = ibuf (sizeyi + ilevel)/2 + 1
          ibuf (sizeyi + ilevel+2) = ibuf (sizeyi + ilevel+1)
          ibuf (sizezi + ilevel) = ibuf (sizezi + ilevel-1)
          ibuf (sizezi + ilevel + 1) = ibuf (sizezi + ilevel)
          ibuf (sizezi + ilevel+2) = ibuf (sizezi + ilevel)/2 + 1
        end do
      end if
      end
