      subroutine mklvlinf (ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1996
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Calculates sizes (MAKEGEOM) and reserves space by appropriate calls
c   to MAKEMATV for vectors and matrices on coarse levels and auxiliary
c   quantities (like LUmat and corr) on all levels.
c   Is also called by autosize in order to estimate the bufferspcae
c   needed.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf (*)

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MAKEGEOM  Fills arrays describing geometry (size, center)  (MG)
c     MAKEMATV  Reserves space for matrix or vector on all levels  (MG)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c   Calculate sizes of all arrays on all levels.
c   Reserve space for all arrays on coarse levels or all levels
c   depending on the type of array.
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call makegeom (ibuf)
      call makematv (matri, 1, 9, ibuf)
      call makematv (rhsri, 1, 1, ibuf)
      call makematv (solri, 1, 1, ibuf)
      call makematv (LUxri, 0, 3, ibuf)
      call makematv (LUyri, 0, 3, ibuf)
      call makematv (resri, 0, 1, ibuf)
      call makematv (corri, 0, 1, ibuf)
      end
