      subroutine isprins2 ( ni, nj, output )
c ======================================================================
c
c        programmer      Guus Segal
c        version         1.0    06-03-1996
c
c
c   copyright (c) 1991-1996  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Write one 2D block to the isnas output file isnascomp.out
c
c **********************************************************************
c
c                  KEYWORDS
c
c   2d
c   write
c **********************************************************************
c
c           INPUT / OUTPUT PARAMETERS
c
      integer ni, nj
      double precision output(ni+1,nj+1)

c     ni        i    Number of non-virtual cells in the i-direction (one block)
c     nj        i    Number of non-virtual cells in the j-direction (one block)
c     output    i    Cartesian components of the flow field in the vertices
c **********************************************************************
c
c                   COMMON BLOCKS
c
      include 'IScommon/cisnas'
c **********************************************************************
c
c                    LOCAL PARAMETERS
c
      integer i, j

c     i         General loop variable
c     j         General loop variable
c **********************************************************************
c
c                         I/O
c
c        The solution is written
c        to the isnas outputfile isnascomp.out (binary or formatted)
c
c        This subroutine only writes one block for one unknown
c
c        Sequence:  (1:ni+1,1:nj+1)
c
c **********************************************************************
c
c                      SUBROUTINES CALLED
c
c
c **********************************************************************
c
c                     ERROR MESSAGES
c
c **********************************************************************
c
c                     PSEUDO CODE
c
c ======================================================================
c
      if ( iref74.gt.0 ) then

c     --- write formatted

         write(iref74,100) ((output(i,j),i=1,ni+1),j=1,nj+1)
100      format(5d16.8)

      else

c     --- write unformatted

         write(-iref74) ((output(i,j),i=1,ni+1),j=1,nj+1)

      end if

      end
