      subroutine iscomlbc ( itopol, leniinbc, lenrinbc, maxtrans,
     +                      nfaces, maxnsubf )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.1    date 03-04-1996 Kees K. dimension itypebc, rtypebc
c                                       plus 1 for the pressure
c        version 1.0    date 07-09-1994
c
c
c   copyright (c) 1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Compute maximal length of arrays iinbc and rinbc as function of the
c    topology
c **********************************************************************
c
c                       KEYWORDS
c
c     compute_length
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer leniinbc, lenrinbc, maxnsubf, maxtrans, nfaces
      integer itopol(*)

c     itopol    i    reserved
c     leniinbc  o    Computed length of array iinbc
c     lenrinbc  o    Computed length of array rinbc
c     maxnsubf  i    Maximum number of subfaces encountered on all subfaces
c     maxtrans  i    Maximum number of transport equations allowed
c     nfaces    i    Number of faces
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer nblocks, ndim

c     nblocks   Number of blocks
c     ndim      Dimension of space (2 or 3)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c    trivial
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c
      call iseropen ( 'iscomlbc' )
      nblocks  = itopol(1)
      ndim     = nfaces/2
      leniinbc = nblocks*nfaces*maxnsubf*(ndim+maxtrans+2)*(ndim+1) +
     +           nblocks*nfaces*2*(ndim-1)
      lenrinbc = nblocks*nfaces*maxnsubf*(maxtrans+ndim)*ndim
      call iserclos ( 'iscomlbc' )
      end
