      subroutine isclossb
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   08-02-1996
c
c
c
c   copyright (c) 1996-1996  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c      End of ISNaS session
c      machine dependent subroutine
c ********************************************************************
c
c                      KEYWORDS
c
c   machine_dependent
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none

c ********************************************************************
c
c
c                COMMON BLOCKS

      include 'IScommon/ciscom'
      include 'IScommon/cisnas'
      include 'IScommon/cfile3'
c ********************************************************************
c
c                LOCAL PARAMETERS
c
      logical check
      integer iref

c     check     Indication if a file has been opened (true) or not (false)
c     iref      Reference to file
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISCLMACH  User closing subroutine
c ********************************************************************
c
c                    I/O
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c ********************************************************************
c
c                    PSEUDO CODE
c
c     If ( paralell acpplication )
c        Send a stop message to all nodes
c        While ( not all nodes have been closed ) do
c           receive data from node
c        Close parallel application
c     Close files
c     Machine dependent close
c ======================================================================
c
c     --- Close Files

      inquire ( iref2, opened=check )
      if ( check ) close ( iref2 )
      inquire ( iref3, opened=check )
      if ( check ) close ( iref3, status='delete' )
      inquire ( irefer, opened=check )
      if ( check ) close ( irefer )

c     --- Files iref10, iref73 and iref74

      iref = abs(iref10)
      inquire ( iref, opened=check )
      if ( check ) close ( iref )
      iref = abs(iref73)
      inquire ( iref, opened=check )
      if ( check ) close ( iref )
      iref = abs(iref74)
      inquire ( iref, opened=check )
      if ( check ) close ( iref )

c     --- Call machine dependent close

      call isclmach

      end
