      subroutine iserclos ( namelc )
c ====================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Extracted from the SEPRAN subroutine
c                                        erclos version 1.1)
c
c
c     copyright (c) 1994  "Ingenieursbureau SEPRA"
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "Ingenieursbureau SEPRA"
c     All rights reserved. No part of this publication may be
c     reproduced, stored in a retrieval system (e.g., in memory, disk,
c     or core) or be transmitted by any means, electronic, mechanical,
c     photocopy, recording, or otherwise, without written Permission
c     from the publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c    removes the name of the local subroutine
c    from the array namsubs in common cismessg/cismessc by reducing levelsub
c
c ********************************************************************
c
c                      KEYWORDS
c
c     concatenate
c ********************************************************************
c
c             INPUT / OUTPUT    PARAMETERS
c
      implicit none
      character*(*) namelc

c     namelc   i    Name of local subroutine that must be concatenated
c ********************************************************************
c
c             COMMON BLOCKS
c
      include 'IScommon/cismessg'
      include 'IScommon/cismessc'
c ********************************************************************
c
c             LOCAL PARAMETERS
c
      integer ncharstr

c     ncharstr  Number of characters in string
c ********************************************************************
c
c             I/O
c
c
c     none.
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c
c     ISERRCHR  Put string in error message file
c     ISERRSUB  Error messages
c ********************************************************************
c
c             ERROR MESSAGES
c
c
c    1417   Name different from name in open subroutine
c ********************************************************************
c
c            PSEUDO CODE
c
c
c     trivial
c ====================================================================

      ncharstr = len(namelc)
      if ( namelc.ne.namsubs(levelsub)(1:ncharstr) ) then

         call iserrchr ( namelc, 1 )
         call iserrchr ( namsubs(levelsub), 2 )
         call iserrsub ( 1417, 0, 0, 2 )

      end if
      levelsub = levelsub - 1

      end
