      subroutine iserrchr ( chr, errvar )
c ====================================================================
c
c        Programmer     Guus Segal
c        version 1.0    date   21-06-94 (Extracted from the SEPRAN subroutine
c                                        errchr version 1.1)
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c*******************************************************************************
c
c                         DESCRIPTION
c
c  auxiliary subroutine to iserrsub. It must be called prior to iserrsub and
c  sets the message variable chr.
c  errvar is the number of the variable to be set(errvar <= 1000).
c*******************************************************************************
c
c                    KEYWORDS
c
c     error_manipulation
c     print
c ********************************************************************
c
c                    INPUT / OUTPUT PARAMETERS
c
      implicit none
      character * (*) chr
      integer errvar

c    chr    i  Character variable to be put into array chars
c    errvar i  Sequence number of variable in ints, reals or chars
c*******************************************************************************
c
c                    COMMON BLOCKS

      include 'IScommon/cismessc'
c*******************************************************************************
c
c                    LOCAL PARAMETERS
c
c*******************************************************************************
c
c                    SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRSUB  Error messages
c ********************************************************************
c
c                    I/O
c
c    none
c ********************************************************************
c
c                    ERROR MESSAGES
c
c    1415   Too many errints, erreals or errchrs in one error message.
c ********************************************************************
c
c                    PSEUDO CODE
c
c    trivial
c ======================================================================
c
      if ( errvar.gt.1000 ) then

c      ERROR: too many chrs in this error message

         call iseropen ('iserrchr')
         call iserrsub (1415, 0, 0, 0)
         call iserclos ('iserrchr')

      else

         chars (errvar) = chr

      endif
      end
