      function isinlog2 (iarg)
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Extracted from the SEPRAN subroutine
c                                        inlog2 version 1.2)
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c   Finds the truncated base 2 logarithm of an integer. If called
c   with negative or zero argument an error is signalled.
c ********************************************************************
c
c                      KEYWORDS
c
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer iarg, isinlog2

c     iarg      i    Integer argument
c     isinlog2  i    Result of computation i.e. 2 log integer
c ********************************************************************
c
c                      COMMON BLOCKS
c
c    -
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      integer jarg

c    jarg    Copy of iarg
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRSUB  Error messages
c ********************************************************************
c
c                    I/O
c
c    none
c ********************************************************************
c
c                    ERROR MESSAGES
c
c    1419   LOG2 called with negative or zero argument
c ********************************************************************
c
c                    PSEUDO CODE
c
c   trivial
c ======================================================================
c
      if ( iarg.le.0 ) then

c     --- ERROR 1419: LOG2 CALLED WITH NEGATIVE OR ZERO ARGUMENT

         call iseropen ( 'isinlog2' )
         call iserrsub ( 1419, 0, 0, 0 )
         call iserclos ( 'isinlog2' )

      end if

      isinlog2 = 0
      jarg = iarg
100   jarg = jarg / 2
      if (jarg.eq.0) go to 1000
      isinlog2 = isinlog2 + 1
      goto 100
1000  continue
      end
