      subroutine isprinbf ( ibuffr, length )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.1    date   06-02-1996 Change print name subroutine
c        version 1.0    date   21-06-1994 Extracted from the SEPRAN subroutine
c                                        prinbf version 1.3
c
c
c   copyright (c) 1994-1996  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c ********************************************************************
c
c                         DESCRIPTION
c
c    check length of array buffer
c    print if necessary
c ********************************************************************
c
c                      KEYWORDS
c
c     memory_management
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS

      integer length, ibuffr(*)

c     ibuffr i/o   reserved
c     length  i    Length of the array in words
c ********************************************************************
c
c                    COMMON BLOCKS
      include 'IScommon/cisnas'
      include 'IScommon/cismessg'
      include 'IScommon/cismessc'
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      integer kbuffr, nbuffr

c     kbuffr  Last position in IBUFFR ever used
c     nbuffr  Length of buffer array ibuffr
c ********************************************************************
c
c                    SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRINT  Put integer value in error message file
c     ISERRSUB  Error messages
c     ISSTOP    Stop ISNAS
c ********************************************************************
c
c                    I/O
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c    1405   Length of array IBUFFR too small
c ********************************************************************
c
c                    PSEUDO CODE
c
c    trivial
c ======================================================================
c
      kbuffr = ibuffr(5)
      nbuffr = ibuffr(7)
      if ( length.gt.nbuffr ) then
         call iseropen ( 'isprinbf' )
         call iserrint ( length, 1 )
         call iserrint ( nbuffr, 2 )
         call iserrsub ( 1405, 2, 0, 0 )
         call iserclos ( 'isprinbf' )
      end if
      if ( ierror.ne.0 ) go to 1000
      if ( length.le.kbuffr ) go to 1000
      if ( ioutpt.ge.1 ) write(irefwr,1) length, namsubs(levelsub)
  1   format(' length of buffer array', i9, '  in subroutine ', a)
      kbuffr = length

1000  if ( ierror.ne.0 ) call isstop
      ibuffr(5) = kbuffr

      end
