      subroutine isreadm3 ( iref )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Subroutine extracted from the SEPRAN
c                                        subroutine READM3 version 1.4)
c
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c       it is read from the next line of
c       the environment file if a file is formatted or unformatted
c       If the file is unformatted the reference number as given at the input
c       is made negative
c       subroutine ISREADM3 is a help subroutine of ISREADMD
c ********************************************************************
c
c                      KEYWORDS
c
c   environment_file
c   read
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer iref

c     iref   i/o  Reference to file
c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/csepch'
      include 'IScommon/cseprd'
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      integer jcolum

c    jcolum     Column number for printing
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISASKNXT  Read next item from the standard input file
c     ISREADCD  Read next card
c ********************************************************************
c
c                    I/O
c
c    One record from the environment file is read
c ********************************************************************
c
c                    ERROR MESSAGES
c
c     No colon found
c     No text found after colon
c     The text found after colon is not (un) formatted
c ********************************************************************
c
c                    PSEUDO CODE
c
c      Read next record (comments excluded):  ISREADCD
c      Find colon
c      Read text after colon
c      If text=unformatted then
c         iref := -iref
c      else if text#formatted then
c         error: wrong text found
c ======================================================================
c
c     --- Read record

      call isreadcd

c     --- Find colon

      ityprd = 0
      jcolum = index ( cards(kcolum:80), ':' )
      if ( jcolum.eq.0 ) then

c     --- No colon found:

         write(*,100) (cards(kcolum:80))
100      format ( ' Line in the environment file does not contain a',
     +            ' colon(:). '//' Execution is terminated'//
     +            ' The line read is:'/1x,a )
         stop

      end if
      jcolum = jcolum + kcolum
      kcolum = jcolum
      icolum = jcolum

      if ( jcolum.gt.80 ) then

c     --- No text found after colon whereas text is expected

         write(*,110) (cards(kcolum:80))
110      format ( ' Line in the environment file does not contain the',
     +            ' text (un)formatted after the colon',
     +            ' (:). '//' Execution is terminated'//
     +            ' The line read is:'/1x,a )
         stop

      end if

      string = ' '
      call isasknxt
      if ( string(1:4).eq.'UNFO' ) then

c     --- UNFORMATTED found, make iref negative

         iref = -iref

      else if ( string(1:4).ne.'FORM' ) then

c     --- Neither the text formatted nor the text unformatted found

         write(*,110) (cards(kcolum:80))
         stop

      end if

      end
