      subroutine isreadwr
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Subroutine extracted from the SEPRAN
c                                        subroutine READWR version 1.1)
c
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c   read a KEYWORD
c
c       This subroutine supposes that the parameter ICOLUM indicates the
c       first position of the keyword. This first position must be a
c       letter.
c        a keyword is defined by a number of letters not segregated by any
c        other character
c
c       After reading the keyword, icolum points to the next position to be read
c
c ********************************************************************
c
c                      KEYWORDS
c
c   read_cards
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none

c
c     none
c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/csepch'
      include 'IScommon/cseprd'
c ********************************************************************
c
c             SUBROUTINES CALLED
c
      logical isasklet

c     ISASKLET   Check if character is a letter or not
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      logical ready

c    ready    Indicates if a while loop is finished or not
c ********************************************************************
c
c                    I/O
c
c    none
c ********************************************************************
c
c                    ERROR MESSAGES
c
c   -
c ********************************************************************
c
c                    PSEUDO CODE
c
c   ready  := false
c   nchar := 0
c   kcolum := icolum
c
c   while ( not ready ) do
c      nchar := nchar+1
c      string(nchar) := cards(icolum)
c      icolum := icolum+1
c      if ( icolum > 80 ) then
c         ready := true
c      else if ( string(nchar) not a letter ) then
c         ready := true
c ======================================================================
c
c     --- Make some initializations

      ready  = .false.
      nchar  = 0
      kcolum = icolum
      string = ' '

100   if ( .not. ready ) then

c     --- While loop

         nchar = nchar + 1
         string(nchar:nchar) = cards(icolum:icolum)
         icolum = icolum + 1

         if ( icolum.gt.80 ) then

c        --- End of record reached

            ready = .true.

         else if ( .not. isasklet(cards(icolum:icolum)) ) then

c        --- Character is not a letter

            ready = .true.

         end if
         go to 100

      end if
      ityprd = 4
      end
