      subroutine isstop
c ======================================================================
c
c        programmer     Guus Segal
c        version 2.7    date 05-01-2000 Guus: fix size of ireq
c        version 2.6    date 05-10-1999 Jason:  added send requests
c        version 2.5    date 21-09-1999 Jason: combined isstop/isfinish
c        version 2.4    date 23-11-1998 Jason: wait for nodes to exit
c        version 2.3    date 13-11-1998 Jason: simplified parallel case
c        version 2.2    date 23-07-1998 Jason: remove unneeded
c                                         check (MPI)
c        version 2.1    date 08-02-1996 Call to isclossb
c        version 2.0    date 01-02-1996 Stop nodes
c        version 1.2    date 30-01-1996 Exit pvm added
c        version 1.1    date 09-05-1995 stop removed
c        version 1.0    date 08-02-1994 Subroutine extracted from the SEPRAN
c                                         subroutine FINISH version 2.5
c
c
c
c   copyright (c) 1994-2000  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c      End of ISNaS session
c      machine dependent subroutine
c **********************************************************************
c
c                       KEYWORDS
c
c      machine_dependent
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, idummy, isource, ilen, ireq(1000)

c     i         General loop variable
c     idummy    dummy integer
c     ilen      length of idummy array (.eq.1)
c     ireq      array of send requests
c     isource   node id number of stopped node
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISCLOSSB       Closing subroutine
c     ISEXITPM       exit pvm
c     ISRECMPI       Receive from node
c     ISSENMPI       Send data to another process
c     ISWAITALL      Wait for all sends to complete
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c

      if ( inodenr.eq.ISHOST ) then

         if ( nerror.ne.0 ) then

c        --- Send stop signal to nodes

            if ( iacnodes.gt.1000 ) then
               call iserrint ( iacnodes, 1 )
               call iserrint ( 1000, 2 )
               call iserrchr ( 'ireq', 1 )
               call iserrsub ( 17, 2, 0, 1 )
               stop
            end if
	    do i = 1, iacnodes
	       ireq(i) = 0
            end do
            do i = 1, iacnodes

               call issenmpi ( idummy, 1, ISINT, i, ICERROR, ireq(i))

            end do

c           --- don't wait for requests, in case a node already aborted

         end if

         do i = 1, iacnodes

c        --- wait for exit signal from all nodes

            ilen = 1
            isource = IS_ANY

            call isrecmpi ( idummy, ilen, ISINT, isource, ICEXNODE )

         end do

      else

c     --- Send node exit message to host

         call issenmpi ( idummy, 1, ISINT, ISHOST, ICEXNODE, ireq(1))
         call iswaitall ( 1, ireq )

      end if

c     --- exit the parallel machine

      if ( iacnodes.gt.0 ) call isexitpm

c     --- Close Files

      call isclossb

      if ( inodenr.eq.ISHOST .and. nerror.gt.0 .or. nwarn.gt.0 ) then
         write(irefwr,100) nerror, nwarn
100      format (// 'ISNaS has been stopped with ',i2, ' errors',
     +              ' and '/ 27x, i3, ' warnings' )
      end if
      stop

c     --- nerror = 1000

      end
