      subroutine diagmu(n,x,b,prec,nprec)
c ==================================================================
c
c
c     programmer       Kees Vuik
c     version 1.0      date 14-05-1992
c     developed at     Convex, HP700
c
c ******************************************************************
c
c                       DESCRIPTION
c
c     Multiplication of x with the diagonal matrix given in prec.
c
c     The array prec sould be filled by subroutine diag.f
c
c ******************************************************************
c
c                       KEYWORDS
c
c     linear_solver
c     diagonal
c     preconditioner
c
c ******************************************************************
c
c                       INPUT / OUTPUT   PARAMETERS
c
c     b      o  the resulting vector after multiplication.
c
c     n      i  number of unknowns in the solution vector.
c
c     nprec  i  number of diagonals, which are used in the pre-
c               conditioning. In this subroutine nprec = 1.
c
c     prec   i  the diagonal preconditioning matrix.
c
c     x      i  the original vector.
c
c ******************************************************************
c
c                       COMMON BLOCKS
c
c
c ******************************************************************
c
c                       LOCAL PARAMETERS
c
c     i      loop counter.
c
c ******************************************************************
c
c                       SUBROUTINES CALLED
c
c ******************************************************************
c
c                       I/O
c
c ******************************************************************
c
c                       ERROR MESSAGES
c
c ******************************************************************
c
c                       PSEUDO CODE
c
c     Multiplication of x with the diagonal matrix given in prec.
c     The result is given in b.
c
c ==================================================================
c
c     Parameters
c
      integer          n,nprec
      double precision prec(1:n,1:nprec),x(n),b(n)
c
c     local parameters
c
      integer i
      do i = 1, n
         b(i) = x(i)*prec(i,1)
      enddo
      return
      end
