      subroutine isscalma ( amat, nusol, ndimso, nconct, diag )
c ======================================================================
c
c        programmer     Kees Vuik
c        version 1.1    date 07-07-1998 Kees V: nusol, nsolut cleaned
c        version 1.0    date 16-01-1995
c
c   copyright (c) 1994-1998  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Subroutine to scale the matrix.
c
c **********************************************************************
c
c                       KEYWORDS
c
c     linear_solver
c     preconditioner
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer          nusol, ndimso, nconct
      double precision amat(1:nusol,1:ndimso,1:nconct),
     +                 diag(1:nusol,1:ndimso)

c     amat      i    The coefficients matrix used in the linear system
c     diag      i    Diagonal matrix stored as vector
c     nconct    i    Number of connections in a row of the matrix
c     ndimso    i    Integer indicating the dimension of the space in
c                    which the problem must be solved (ndimso = 1 or ndim)
c     nusol     i    Number of unknowns for one degree of freedom in
c                    one block
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, j, k

c     i         General loop variable
c     j         General loop variable
c     k         General loop variable
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c    In this subrotuine a row scaling of the matrix is performed
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c

      do k = 1, nconct
         do j = 1, ndimso
            do i = 1, nusol
               amat(i,j,k) = amat(i,j,k)*diag(i,j)
            end do
         end do
      end do

      end
