      subroutine isremfil ( ifile )
c ======================================================================
c
c        programmer   Guus Segal
c        version 1.0    date   13-07-95
c
c
c
c   copyright (c) 1995  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c ********************************************************************
c
c                         DESCRIPTION
c
c    Remove file indicated by ifile if it exists
c
c ********************************************************************
c
c                      KEYWORDS
c
c    machine_dependent
c    delete_file
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer ifile

c     ifile    i   File reference number
c ********************************************************************
c
c
c                   COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cisnasch'
      include 'IScommon/cfile3'
c ********************************************************************
c
c                       LOCAL PARAMETERS
c
c
      integer iref
      character * 50 name
      logical check

c     check     Indication if a file has been opened (true) or not (false)
c     iref      Reference to file
c     name      Name of file
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c   -
c ********************************************************************
c
c                    I/O
c
c    none
c ********************************************************************
c
c                    PSEUDO CODE
c
c   trivial
c ======================================================================
c
c     --- ifile = 73 (sepcomp.inf), 74 (sepcomp.out)
c         or 75 (isnasinp.cmp)

         if ( abs(ifile).eq.73 ) then

            name = name73
            iref = abs(iref73)

         else if ( abs(ifile).eq.74 ) then

            name = name74
            iref = abs(iref74)

         else if ( abs(ifile).eq.75 ) then

            name = name75
            iref = abs(iref75)

         end if

         inquire ( file=name, exist=check )
         if ( check ) then

            open ( unit = iref, file = name )
            close ( unit = iref, status = 'delete' )

         end if

      end
