      subroutine issenchr ( ibufptr, icount, itype, idest, icontext,
     +                      ireq )
c ======================================================================
c
c        Programmer     Jason Frank
c        version 1.1    date 05-10-1999  Jason: send-requests added
c        version 1.0    date 05-10-1998
c
c     copyright (c) 1998-1999  "TU-Delft"
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "TU-Delft"
c     All rights reserved. No part of this publication may be
c     reproduced, stored in a retrieval system (e.g., in memory, disk,
c     or core) or be transmitted by any means, electronic, mechanical,
c     photocopy, recording, or otherwise, without written Permission
c     from the publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Wrapper for MPI_SEND.
c     This implementation is completely based on MPI
c **********************************************************************
c
c                       KEYWORDS
c
c     parallel
c     send
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer icount, itype, idest, icontext, ireq
      character ibufptr(*)

c     ibufptr  i    pointer to first element of array to be sent
c     icount   i    the length of array to be sent
c     icontext i    the communication context, (message tag)
c     idest    i    rank of the destination process
c     ireq     i    MPI request
c     itype    i    MPI datatype
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
cpar      integer ierr
cpar      include 'mpif.h'

c     ierr      error status of an MPI call ( .eq.MPI_SUCCESS if ok)
c **********************************************************************
c
c                       I/O
c
c     Information is sent to host or node 
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRINT  Put integer value in error message file
c     ISERRSUB  Error message subroutine
c     MPI_SEND  Immediately sends the data in the active MPI message buffer
c **********************************************************************
c
c                       ERROR MESSAGES
c
c    1750   MPI error
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call iseropen ( 'issenmpi' )

cpar      call MPI_ISEND ( ibufptr, icount, itype, idest, 
cpar     +   icontext, MPI_COMM_WORLD, ireq, ierr)
cpar      if ( ierr.ne.MPI_SUCCESS ) then
cpar         call iserrint ( ierr, 1 )
cpar         call iserrsub ( 1750, 1, 0, 0 )
cpar      end if

      call iserclos ( 'issenmpi' )
      end
