#include <sys/types.h>   /* /usr/include/sys/types.h */
#include <sys/times.h>   /* /usr/include/sys/times.h */
#include <unistd.h>      /* /usr/include/unistd.h */

/* invoer: - ;
 * uitvoer: - ;
 * externals: long tickstart, verblijfstijd t.o.v. een vast tijdstip voor huidi-
 *               ge program-executie, in 1/CLK_TCK seconden, is return value;
 *               hier door times() gezet, in asktim() gebruikt; voor CLK_TCK,
 *               zie TIMES(2);
 *            unsigned notsettim, hier op 0 gezet (op ~0 geinitialiseerd door
 *               asktim() ) om aan te geven dat deze function minstens 1 maal is
 *               aangeroepen; gebruikt in asktim(), zie aldaar;
 * aangeroepen door: gebruikers-programma;
 * roept aan: times() (zie TIMES(2)).
 * een aanroep van deze function dient aan alle aanroepen van asktim() in het
 * huidige program vooraf te gaan, zoniet dan melding door asktim en doorgaan
 * van aanroepende program.
 * installatie en gebruik:
 *   compileren met cc -c filenaam.c, geeft filenaam.o (zie CC(1)),
 *   in bibliotheek zetten met ar r /usr/lib/libthd.a filenaam.o (zie AR(1)),
 *   link-en met de ld option -l, kan via compiler doorgegeven worden aan ld
 *   door -lthd achteraan het complete compile-command te plaatsen:
 *      compile-command [options] filenaam ... -lthd (zie LD(1) en betreffende
 *   COMPILE-COMMAND(1) ).
 */

extern unsigned notsettim;
long hz;
clock_t tickstart;

#ifdef UNDERSCORE
   void issettim_()
#else
#ifdef CRAY
   void ISSETTIM()
#else
   void issettim()
#endif
#endif
{ clock_t times();
  long sysconf();
  struct tms buf;

  if ( notsettim ) notsettim = 0;
/*
 */
  /* bepaal aantal ticks per second (machine afhankelijk): */
  hz = sysconf(_SC_CLK_TCK);
  /* voor _SC_CLK_TCK, zie SYSCONF(2) en TIMES(2) */
  tickstart = times(&buf);
} /* end of settim */
